Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.formula
Class ParamDesc

    java.lang.Object
      jet.formula.ParamDesc

All Implemented Interfaces:
  java.io.Serializable

    public class ParamDesc

extends java.lang.Object
implements java.io.Serializable

See Also:
  Serialized Form

Field Summary
`static int` | `ADOPT_DIRECTLY`
`static int` | `AUTO`
`static java.lang.String` | `DATEFMT`
`static int` | `dateStyle` The default style of the date & time format of the Date type parameter and the DateTime type parameter.
`static java.lang.String` | `DATETIMEFMT`
`jet.parameter.definition.Definition` | `def`
`static java.util.Locale` | `defaultLocale` The default locale.
`static int` | `GROUPSORT` This type indicates that the current parameter is used with Dynamic Group/Sort feature.
`static int` | `IMPORT`
`boolean` | `isStringNull`
`java.lang.String` | `name` The name of a parameter.
`static int` | `NORMAL` This type indicates that the current parameter does not associate with a column list.
`java.lang.String` | `promptText` The prompt of a parameter.
`static int` | `PSEUDO` This type indicates that the current parameter is used with BindParameter feature.
`jet.parameter.runtime.ParameterRuntime` | `rt`
`static int` | `SORTORDER` This type indicates that the current parameter is used with SortOrderByParameter feature.
`java.lang.String` | `stringFormat`
`static int` | `timeStyle`
`java.lang.String` | `type` The data type of a parameter.
`static java.lang.String` | `TYPE_BOOLEAN`
`static java.lang.String` | `TYPE_CURRENCY`
`static java.lang.String` | `TYPE_DATE`
`static java.lang.String` | `TYPE_DATETIME`
`static java.lang.String` | `TYPE_INTEGER` The data type constants of parameter.
`static java.lang.String` | `TYPE_NUMBER`
`static java.lang.String` | `TYPE_PARAMETER` The constant of a parameter's data type supports nested parameter.
`static java.lang.String` | `TYPE_PARAMETER_SEPARATOR1`
`static java.lang.String` | `TYPE_PARAMETER_SEPARATOR2`
`static java.lang.String` | `TYPE_STRING`
`static java.lang.String` | `TYPE_TIME`
`static int` | `USE_DEFAULT`
`static int` | `WARN`

Constructor Summary
`ParamDesc()`
`ParamDesc(java.lang.String name, java.lang.String type, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int index)` Creates a parameter.
`ParamDesc(java.lang.String name, java.lang.String type, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int index, boolean isMultipleValue)` Creates a parameter.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, int isColumn)` Constructs a ParamDesc which will not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, int isColumn, boolean isMultipleValue)` Constructs a ParamDesc which will not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, int isColumn, java.lang.String column, java.util.Vector columns, java.util.Vector vShowValue, java.lang.String binding)` Constructs a ParamDesc which will not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, int isColumn, java.lang.String column, java.util.Vector columns, java.util.Vector vShowValue, java.lang.String binding, boolean isMultipleValue)` Constructs a ParamDesc which will not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, int isColumn, java.lang.String column, java.util.Vector columns, java.util.Vector vShowValue, java.lang.String binding, boolean isDis, boolean isReq)` Construcing column, t a ParamDesc which not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, int isColumn, java.lang.String column, java.util.Vector columns, java.util.Vector vShowValue, java.lang.String binding, boolean isDis, boolean isReq, boolean isMultipleValue)` Construcing column, t a ParamDesc which not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, java.lang.String binding)` Constructs a ParamDesc which will not be parsed.
`ParamDesc(java.lang.String strName, java.lang.String strType, java.lang.String prompt, java.util.Vector vStrLimit, java.util.Vector vStrValue, java.lang.String strFormat, int operator, int intdex, java.lang.String binding, boolean isMultipleValue)` Constructs a ParamDesc which will not be parsed.

Method Summary
`void` | `addReferParamToVsortParams(java.util.Hashtable allParam, java.util.Hashtable curParamDescs, java.util.Vector sortParam)`
`boolean` | `allowUseExpression()`
`static java.util.Vector` | `changedHashToVector(java.util.Hashtable hash)`
`static java.util.Hashtable` | `changedVectorToHash(java.util.Vector v)`
`void` | `check(java.lang.String value, java.util.Locale locale)` Checks the value validation.
`void` | `clearMem()`
`void` | `clearReferedBy()`
`java.lang.Object` | `clone()`
`void` | `copy(ParamDesc that)` Copy the current value, value list of specified (that) parameter to this parameter without checking the value is out of range or not.
`java.lang.String[]` | `detectInvalidValues(java.lang.String[] target, java.util.Locale locale)` Deprecated. `setValue` method will do the outOfRange check, this method is useless now
`boolean` | `equals(ParamDesc param)` Does not compare name.
`java.lang.String` | `format(DbValue v, java.lang.String pattern, java.util.Locale l, java.util.TimeZone z)` FeatureImplement #118058 FeatureImplement_NLS enhancement
`java.lang.String[]` | `formatMultiple(fArray v, java.lang.String pattern, java.util.Locale l, java.util.TimeZone z)`
`static void` | `getAllRelatedParamByValue(java.util.Hashtable allPara, java.util.Vector referPara, ParamDesc param, java.lang.Object value)` If a parameter's type is parameters, gets all related parameters according to the value.
`int` | `getBeColumn()`
`java.lang.String` | `getBinding()` This method is associated with DynamicSortOrder feature.
`java.lang.String[][]` | `getBooleanLiteral()`
`java.lang.String` | `getBVName()`
`java.lang.String` | `getChainID()`
`DbColDesc` | `getColDesc()`
`java.lang.String` | `getColumn()` This method is associated with BindParameter feature.
`java.util.Vector` | `getColumns()` This method is associated with BindParameter feature.
`java.lang.String` | `getDataSource()` Returns the data source name of 1) when this paramDesc is type in NON dynamic parameter, the return value is the data source name in which this parameter is defined 2) bind column parameter (include cascading) and not dynamic parameter, returns the data source name of the columns bind to this parameter 3) when this paramDesc is type is dynamic parameter, the return value is uncertain 4) when this paramDesc is type is bind column parameter (include cascading) dynamic parameter, returns the data source name of the BV whose elements are bound to this parameter
`java.lang.String` | `getDefaultDateFormat(java.util.Locale loc)` This method can only be called when no user format is defined.
`int` | `getDefaultIndex()` Returns the index of the current value in the value list.
`java.lang.String` | `getDefaultValue()` Returns the nth item in the value list which corresponds to the current value of this parameter.
`java.util.Vector` | `getDefaultValues()` Gets all the default values' strings which do not caring format and locale.
`jet.parameter.definition.Definition` | `getDefinition()` returns the Definition object of the parameter
`java.util.Vector` | `getDisplayLimit(java.util.Locale locale)` Returns the limit values, caring the format.
`java.lang.String` | `getDisplayValue(DbValue paramvalue, java.util.Locale locale)` Gets the display string based on the locale of the string saved in the catalog.
`java.lang.String` | `getDisplayValue(DbValue paramvalue, java.util.Locale locale, java.util.TimeZone z)`
`java.util.Vector` | `getDisplayValues(java.util.Locale locale)` Formats all the values in the value list.
`java.lang.String` | `getDynamicTemplate()`
`DbValue` | `getDynamicValue(long dynamicValue, java.util.Locale local)` Gets a dynamic value[Date, Time, DateTime] base on a dynamic template and input the long time, and the local.
`static void` | `getFirstLevelParam(java.util.Hashtable allPara)`
`static java.util.Vector` | `getFirstLevelRelatedParamByValue(java.util.Hashtable allPara, ParamDesc param, java.lang.Object value)` This meyhod is for server, which gets the related paramDesc according to the parameter's value, and only one level.
`static void` | `getFirstShowParamDescs(java.util.Hashtable allPara, java.util.Vector referPara, ParamDesc param, java.lang.Object value)` If a parameter's type is parameters, If this value's corresponding parameter type is parameters, gets the corresponding parameter of this parameter default value.
`java.lang.String` | `getFormat()` Returns the format.
`java.util.Vector` | `getImportParams()`
`java.lang.String` | `getImportSql()`
`jet.formula.SymbolInfo` | `getInfo()`
`java.lang.String` | `getInternalValue()`
`java.util.Vector` | `getLimit()` Returns the limit values, not caring the format.
`java.lang.String` | `getLocalizedUserFormat(java.util.Locale locale)`
`java.lang.String[]` | `getMultiDisplayValue(fArray paramvalue, java.util.Locale locale)`
`java.lang.String[]` | `getMultiDisplayValue(fArray paramvalue, java.util.Locale locale, java.util.TimeZone z)`
`java.lang.String[]` | `getMultiStrValue()`
`java.lang.String` | `getName()` Returns the parameter name.
`java.lang.String` | `getNextLevel()`
`int` | `getOperation()` Returns the operation used in the limitation.
`jet.parameter.runtime.ParameterRuntime` | `getParameterRuntime()` Returns the runtime object of the parameter.
`java.lang.String` | `getPreviousLevel()`
`java.lang.String` | `getPrompt()` Returns the prompt of the parameter.
`java.lang.String` | `getQueryName()`
`java.util.Vector` | `getReferedBy()`
`static java.util.Vector` | `getReferPara(java.util.Hashtable allPara)` Gets all parameters which is referenced by other parameters.
`static void` | `getRelatedParamDescsByParam(java.util.Hashtable allPara, java.util.Vector referPara, ParamDesc param)` If a parameter's type is Parameters, this method can be used to get all related parameter desc.
`java.lang.String` | `getSecurityEntry()`
`java.util.Vector` | `getSelectedValues()`
`java.util.Vector` | `getShowValues()` Gets the value list of a bind type parameter.
`java.lang.String` | `getStrValue()`
`java.lang.String` | `getType()` Gets the parameter type
`java.util.Vector<ParamDesc>` | `getUpperLevels()`
`DbValue` | `getValue()` Returns the current value of the parameter.
`java.util.Vector[]` | `getValueList()`
`java.util.Vector<jet.parameter.runtime.valuelist.item.ValueListItem>` | `getValueList(java.util.Locale l)`
`java.util.Vector<jet.parameter.runtime.valuelist.item.ValueListItem>` | `getValueList(java.util.Locale l, boolean needTranslate)` For FS #118058 FeatureImplement_NLS enhancement This method can translate each item of a parameter value list into another language.
`java.lang.String` | `getValueMeaning()` Gets the current string value meaning of the parameter based on the current locale and format.
`java.util.Vector` | `getValues()` Gets all the values, not caring the format.
`java.util.Vector` | `getValues(java.util.Locale loc)`
`java.util.Vector` | `getValues(java.util.Locale loc, java.util.TimeZone z)` Returns the value list of a parameter.
`int` | `getWhenOutOfRange()`
`static boolean` | `hasImportParam(java.util.Vector allPara)` If a parameter has import SQL and uses other parameters, returns true, else returns false.
`static boolean` | `hasNestedPara(java.util.Hashtable allPara)` This method checks whether the parameter's type is parameters or not for all parameters.
`void` | `initParam(java.util.Locale locale)` Initializes the defalut value, and parse it.
`boolean` | `isAllowAll()`
`boolean` | `isAllowTypeIn()`
`boolean` | `isAllSelected()`
`boolean` | `isBindColumn()`
`boolean` | `isCascading()` This flag must be set by calling setBeColumn(ParamDesc.CASCADING).
`boolean` | `isColumn()` Checks whether the parameter is bound with a column.
`boolean` | `isColumnCal()`
`boolean` | `isDistinct()`
`boolean` | `isDynamicParam()`
`boolean` | `isGetValueFromAPI()`
`boolean` | `isHideParameterWhenSingleValueReturn()`
`static boolean` | `isImportByPara(ParamDesc param, ParamDesc curParam, java.util.Vector paramDescs)`
`boolean` | `isMultipleValue()`
`boolean` | `IsParameters()`
`boolean` | `isReferedBy()` Checks whether this paramDesc refers to by other paramDesc no matter through old(or new)cascading or by query.
`boolean` | `isReferOther()` Checks whether this paramDesc refers to other paramDesc no matter through old(or new)cascading or by query.
`boolean` | `isRequired()` Whether this parameter is required or can be ignored.
`boolean` | `isSetAsParameter()`
`boolean` | `isSimilar(ParamDesc param)` Judges whether the parameter specified is similar to this one.
`boolean` | `isUseCurrentDate()` If returnS true, the parameter is a dynamic date parameter.
`boolean` | `isUseCurrentDateWhenBlank()` If returns true, the parameter will return the current date when the parameter is blank.
`boolean` | `isValuesNotEmpty()`
`boolean` | `needLoadValueList()`
`DbValue` | `parseInternalValue(java.lang.String inValue)` Checks whether the internal string (saved in the catalog) is OK.
`DbValue` | `parseValue(java.lang.String val, java.util.Locale locale, boolean isExternal)`
`DbValue` | `parseValue(java.lang.String val, java.util.Locale locale, java.util.TimeZone z, boolean isExternal)`
`void` | `resetTimeBaseLine(java.sql.Timestamp timeBaseLine)`
`void` | `set(DbValue v)`
`void` | `setAllowAll(boolean allow)`
`void` | `setAllowTypeIn(boolean allowTypeIn)`
`void` | `setAllowUseExpression(boolean allowUseExpression)`
`void` | `setAllSelected(boolean isAllSelected)`
`void` | `setBeColumn(int b)`
`void` | `setBinding(java.lang.String binding)`
`void` | `setBVName(java.lang.String bvName)`
`void` | `setCascadingInfo(java.lang.String chainID, java.lang.String previousLevel, java.lang.String nextLevel, boolean isSetAsParameter)`
`void` | `setColumn(java.lang.String column)`
`void` | `setColumns(java.util.Vector v)`
`void` | `setDatamapping(java.lang.String dataMapping)`
`void` | `setDataMappingFile(java.lang.String dataMapping)`
`void` | `setDataSource(java.lang.String sourceName)`
`void` | `setDefaultIndex(int i)` Selects the nth value in the value list as the current value.
`void` | `setDefaultValue(int index)`
`void` | `setDistinct(boolean isDis)`
`boolean` | `setDynamicTemplate(java.lang.String dynamicTemplate)` If the set dynamicTemplate is legal, replaces previous the dynamicTemplate with the currently set dynamicTemplate, and returns true.
`void` | `setEncoding(java.lang.String encoding)`
`void` | `setFormat(java.lang.String str)` Sets the format or sets the encoding of a string type parameter.
`void` | `setGetValueFromAPI(boolean b)`
`void` | `setHideParameterWhenSingleValueReturn(boolean isHideParameterWhenSingleValueReturn)`
`void` | `setImportParams(java.util.Vector importParams)`
`void` | `setImportSql(java.lang.String importSql)`
`void` | `setIsCascading(boolean isCascading)`
`void` | `setIsDynamicParam(boolean isDynamicParam)`
`void` | `setIsMultipleValue(boolean isMultipleValue)`
`void` | `setLimit(java.lang.String lim, java.util.Locale locale, int indexLimit)` Sets one limination value, and the indexLimit is from 0 to the vDbLimit.size() - 1.
`void` | `setLimit(java.util.Vector vStrLimit, java.util.Locale locale)` Sets the limination, and does not recheck whether all the values in the value list are valid based on the new limination.
`void` | `setNLSApplyParam(jet.util.nls.NLSApplyParam nls)`
`void` | `setPrompt(java.lang.String str)`
`void` | `setQueryName(java.lang.String queryName)`
`void` | `setRequired(boolean isReq)`
`void` | `setSecurityEntry(java.lang.String entry)`
`void` | `setSelectedValues(java.util.Vector selectedValues)`
`void` | `setShowValues(java.util.Vector values)`
`boolean` | `setUseCurrentDate(boolean useCurrentDate)` Sets the parameter whether it is a dynamic date parameter or not.
`boolean` | `setUseCurrentDateWhenBlank(boolean useCurrentDateWhenBlank)` Sets the parameter if the parameter will return the current date when the parameter is blank.
`java.lang.String` | `setValue(DbValue val, java.util.Locale locale)` Sets the user input value, and returns the display value based on the locale.
`java.lang.String[]` | `setValue(fArray val, java.util.Locale locale)`
`java.lang.String[]` | `setValue(java.lang.String[] inputValues, java.util.Locale locale)` Deprecated. Replaced by `setValue(UserInput[], Timestamp, Locale)`
`java.lang.String` | `setValue(java.lang.String outVal, java.util.Locale locale)` Deprecated. Replaced by `setValue(UserInput, Timestamp, Locale)`
`void` | `setValue(jet.parameter.UserInput[] input, java.sql.Timestamp timeBaseLine, java.util.Locale locale)`
`void` | `setValue(jet.parameter.UserInput[] input, java.sql.Timestamp timeBaseLine, java.util.Locale locale, java.util.TimeZone z)` Set the user inputs to parameter when parameter is multiple value.
`void` | `setValue(jet.parameter.UserInput input, java.sql.Timestamp timeBaseLine, java.util.Locale locale)`
`void` | `setValue(jet.parameter.UserInput input, java.sql.Timestamp timeBaseLine, java.util.Locale locale, java.util.TimeZone z)` Set the user input to parameter.
`void` | `setValueList(java.util.Vector values)` Deprecated.
`void` | `setValueList(java.util.Vector values, java.util.Vector showValues)`
`void` | `setValues(java.util.Vector vStrValue, java.util.Locale locale)` Sets(or changes) the value list of this parameter.
`void` | `setValues(java.util.Vector vStrValue, java.util.Locale locale, DbValue currentValue)`
`void` | `setWhenOutOfRange(int whenOutOfRange)`
`static java.lang.String[]` | `splitValue(java.lang.String value)`
`java.lang.String` | `toString()`
`void` | `transferValues(ParamDesc param)`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### TYPE_INTEGER

    public static final java.lang.String TYPE_INTEGER

  The data type constants of parameter.

  See Also:
    Constant Field Values

### TYPE_NUMBER

    public static final java.lang.String TYPE_NUMBER

See Also:
  Constant Field Values

### TYPE_STRING

    public static final java.lang.String TYPE_STRING

See Also:
  Constant Field Values

### TYPE_CURRENCY

    public static final java.lang.String TYPE_CURRENCY

See Also:
  Constant Field Values

### TYPE_BOOLEAN

    public static final java.lang.String TYPE_BOOLEAN

See Also:
  Constant Field Values

### TYPE_DATE

    public static final java.lang.String TYPE_DATE

See Also:
  Constant Field Values

### TYPE_TIME

    public static final java.lang.String TYPE_TIME

See Also:
  Constant Field Values

### TYPE_DATETIME

    public static final java.lang.String TYPE_DATETIME

See Also:
  Constant Field Values

### TYPE_PARAMETER

    public static final java.lang.String TYPE_PARAMETER

  The constant of a parameter's data type supports nested parameter. If the data type of a parameter is 'parameter', then, in designer, each item in the value list of this parameter is used as that of other parameters which will be applied in a report, and the parameter input dialog will only show these parameters whose names are included in the current value of this parameter.

  See Also:
    Constant Field Values

### TYPE_PARAMETER_SEPARATOR1

    public static final java.lang.String TYPE_PARAMETER_SEPARATOR1

See Also:
  Constant Field Values

### TYPE_PARAMETER_SEPARATOR2

    public static final java.lang.String TYPE_PARAMETER_SEPARATOR2

See Also:
  Constant Field Values

### type

    public java.lang.String type

  The data type of a parameter.

### defaultLocale

    public static final java.util.Locale defaultLocale

  The default locale.

### dateStyle

    public static final int dateStyle

  The default style of the date & time format of the Date type parameter and the DateTime type parameter.

  See Also:
    `java.text.DateFormat.LONG`, Constant Field Values

### timeStyle

    public static final int timeStyle

See Also:
  Constant Field Values

### DATETIMEFMT

    public static final java.lang.String DATETIMEFMT

See Also:
  Constant Field Values

### DATEFMT

    public static final java.lang.String DATEFMT

See Also:
  Constant Field Values

### NORMAL

    public static final int NORMAL

  This type indicates that the current parameter does not associate with a column list.

  See Also:
    Constant Field Values

### GROUPSORT

    public static final int GROUPSORT

  This type indicates that the current parameter is used with Dynamic Group/Sort feature.

  See Also:
    Constant Field Values

### AUTO

    public static final int AUTO

See Also:
  Constant Field Values

### IMPORT

    public static final int IMPORT

See Also:
  Constant Field Values

### PSEUDO

    public static final int PSEUDO

  This type indicates that the current parameter is used with BindParameter feature.

  See Also:
    Constant Field Values

### SORTORDER

    public static final int SORTORDER

  This type indicates that the current parameter is used with SortOrderByParameter feature.

  See Also:
    Constant Field Values

### name

    public java.lang.String name

  The name of a parameter.

### promptText

    public java.lang.String promptText

  The prompt of a parameter.

### isStringNull

    public boolean isStringNull

### stringFormat

    public java.lang.String stringFormat

### def

    public final jet.parameter.definition.Definition def

### rt

    public final jet.parameter.runtime.ParameterRuntime rt

### ADOPT_DIRECTLY

    public static final int ADOPT_DIRECTLY

See Also:
  Constant Field Values

### USE_DEFAULT

    public static final int USE_DEFAULT

See Also:
  Constant Field Values

### WARN

    public static final int WARN

See Also:
  Constant Field Values

Constructor Detail

### ParamDesc

    public ParamDesc()

### ParamDesc

    public ParamDesc(java.lang.String name,
                     java.lang.String type,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int index)

  Creates a parameter.

  Parameters:
    `name` - The name of the parameter.
    `type` - The type of the parameter.
    `prompt` - The prompt string of the parameter.
    `vStrLimit` - The value limitation vector of the parameter, not caring display format.
    `vStrValue` - The initial value vector of the parameter, not caring display format.
    `strFormat` - The format which is used to display the parameter's value.
    `operator` - Now the value is jet.api.ParameterInfo.BETWEEN or jet.api.ParameterInfo.UNKNOWN.
    `index` - The default value index in the vStrValue.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     java.lang.String binding)

  Constructs a ParamDesc which will not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     int isColumn)

  Constructs a ParamDesc which will not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     int isColumn,
                     java.lang.String column,
                     java.util.Vector columns,
                     java.util.Vector vShowValue,
                     java.lang.String binding)

  Constructs a ParamDesc which will not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     int isColumn,
                     java.lang.String column,
                     java.util.Vector columns,
                     java.util.Vector vShowValue,
                     java.lang.String binding,
                     boolean isDis,
                     boolean isReq)

  Construcing column, t a ParamDesc which not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String name,
                     java.lang.String type,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int index,
                     boolean isMultipleValue)

  Creates a parameter.

  Parameters:
    `name` - The name of the parameter.
    `type` - The type of the parameter.
    `prompt` - The prompt string of the parameter.
    `vStrLimit` - The value limitation vector of pthe arameter, not caring display format.
    `vStrValue` - The initial value vector of the parameter, not carinf display format.
    `strFormat` - The format which is used to display the parameter's value.
    `operator` - Now the value is jet.api.ParameterInfo.BETWEEN or jet.api.ParameterInfo.UNKNOWN.
    `index` - The default value index in the vStrValue.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     java.lang.String binding,
                     boolean isMultipleValue)

  Constructs a ParamDesc which will not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     int isColumn,
                     boolean isMultipleValue)

  Constructs a ParamDesc which will not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     int isColumn,
                     java.lang.String column,
                     java.util.Vector columns,
                     java.util.Vector vShowValue,
                     java.lang.String binding,
                     boolean isMultipleValue)

  Constructs a ParamDesc which will not be parsed.

### ParamDesc

    public ParamDesc(java.lang.String strName,
                     java.lang.String strType,
                     java.lang.String prompt,
                     java.util.Vector vStrLimit,
                     java.util.Vector vStrValue,
                     java.lang.String strFormat,
                     int operator,
                     int intdex,
                     int isColumn,
                     java.lang.String column,
                     java.util.Vector columns,
                     java.util.Vector vShowValue,
                     java.lang.String binding,
                     boolean isDis,
                     boolean isReq,
                     boolean isMultipleValue)

  Construcing column, t a ParamDesc which not be parsed.

Method Detail

### getInternalValue

    public java.lang.String getInternalValue()

### setSecurityEntry

    public void setSecurityEntry(java.lang.String entry)

### getSecurityEntry

    public java.lang.String getSecurityEntry()

### getDefinition

    public jet.parameter.definition.Definition getDefinition()

  returns the Definition object of the parameter

  Returns:

### getParameterRuntime

    public jet.parameter.runtime.ParameterRuntime getParameterRuntime()

  Returns the runtime object of the parameter.

  Returns:

### getDefaultValues

    public java.util.Vector getDefaultValues()

  Gets all the default values' strings which do not caring format and locale.

### getInfo

    public jet.formula.SymbolInfo getInfo()

### getValue

    public DbValue getValue()

  Returns the current value of the parameter. Note: calling below methods will change the current value: setValue, set, and setDefaultIndex. If a ParamDesc is defined with a value list, then the current value of a newly created instance (any of the above 3 methods is not called yet) of ParamDesc will be the one in the value list specified at a defined time. If a ParamDesc represents a bind column parameter(including part of cascading parameter), when it is the first time to set a value list by setValues() and any of the above 3 methods is not called, calling getValue() will select the last item in the value list as the current value and return it, provided the value list is not empty. For an empty or undefined value list, the current value of a newly created instance (any of the above 3 methods is not called yet) of ParamDesc will be a DbValue with its bNull attribute = true.

### getStrValue

    public java.lang.String getStrValue()

### set

    public void set(DbValue v)
             throws jet.exception.InvalidParameterException

  Throws:
    `jet.exception.InvalidParameterException`

### getValueMeaning

    public java.lang.String getValueMeaning()

  Gets the current string value meaning of the parameter based on the current locale and format.

  If no value, returns null string.

### getColDesc

    public DbColDesc getColDesc()

### initParam

    public void initParam(java.util.Locale locale)
                   throws jet.exception.InvalidParameterException

  Initializes the defalut value, and parse it.

  Throws:
    `jet.exception.InvalidParameterException`

### setBeColumn

    public void setBeColumn(int b)

### getBeColumn

    public int getBeColumn()

### isColumn

    public boolean isColumn()

  Checks whether the parameter is bound with a column.

### isColumnCal

    public boolean isColumnCal()

### setLimit

    public void setLimit(java.util.Vector vStrLimit,
                         java.util.Locale locale)
                  throws jet.exception.InvalidParameterException

  Sets the limination, and does not recheck whether all the values in the value list are valid based on the new limination. Please call checkAllValues to check.

  Throws:
    `jet.exception.InvalidParameterException`

### setLimit

    public void setLimit(java.lang.String lim,
                         java.util.Locale locale,
                         int indexLimit)
                  throws jet.exception.InvalidParameterException

  Sets one limination value, and the indexLimit is from 0 to the vDbLimit.size() - 1.

  Throws:
    `jet.exception.InvalidParameterException`

### getBooleanLiteral

    public java.lang.String[][] getBooleanLiteral()

### clearMem

    public void clearMem()

### parseValue

    public DbValue parseValue(java.lang.String val,
                              java.util.Locale locale,
                              java.util.TimeZone z,
                              boolean isExternal)
                       throws jet.exception.InvalidParameterException

  Throws:
    `jet.exception.InvalidParameterException`

### parseValue

    public DbValue parseValue(java.lang.String val,
                              java.util.Locale locale,
                              boolean isExternal)
                       throws jet.exception.InvalidParameterException

  Throws:
    `jet.exception.InvalidParameterException`

### getDefaultValue

    public java.lang.String getDefaultValue()

  Returns the nth item in the value list which corresponds to the current value of this parameter. The n is indicated by the return value of getDefaultIndex(). The return value of this method is possibly not corresponding to the return value of getValue(), which is the current value, if setValues() is called but setDefaultIndex() or setValue() is not called. The return value does not care the format and locale(TODO: clarify). If the value list is empty, "" is returned.

### getDisplayValue

    public java.lang.String getDisplayValue(DbValue paramvalue,
                                            java.util.Locale locale)

  Gets the display string based on the locale of the string saved in the catalog.

  If no value, returns null string.

### getDisplayValue

    public java.lang.String getDisplayValue(DbValue paramvalue,
                                            java.util.Locale locale,
                                            java.util.TimeZone z)

### getDisplayValues

    public java.util.Vector getDisplayValues(java.util.Locale locale)

  Formats all the values in the value list. If a user format is set, use the user format, otherwise, do it based on the input locale.

### needLoadValueList

    public boolean needLoadValueList()

### isBindColumn

    public boolean isBindColumn()

### getValues

    public java.util.Vector getValues()

  Gets all the values, not caring the format. If it is a bind type parameter, the order matches `getShowValues`. NOTE: the values are formatted by "yyyy-MM-dd HH:mm:ss.SSS" and timezone "GMT". It's highly recommanded to call getDisplayValues(Locale) instead.

  See Also:
    `getShowValues`

### getValues

    public java.util.Vector getValues(java.util.Locale loc,
                                      java.util.TimeZone z)

  Returns the value list of a parameter. Each element of the returned vector is a `UserInput` object. If an element is not an expression, its `getUserInput()` method will return a same string as `getDisplayValue(Locale)`. But if the loc is null, these non-expression elements will be same as getValues().

  Parameters:
    `loc` -
  Returns:

### getValues

    public java.util.Vector getValues(java.util.Locale loc)

### isValuesNotEmpty

    public boolean isValuesNotEmpty()

### getType

    public java.lang.String getType()

  Gets the parameter type

### getName

    public java.lang.String getName()

  Returns the parameter name.

### getPrompt

    public java.lang.String getPrompt()

  Returns the prompt of the parameter.

### getLimit

    public java.util.Vector getLimit()

  Returns the limit values, not caring the format. changed by zhaosy,2004/12/24, fixed the bug about the number,currency parameter getlimit method have format

### getDisplayLimit

    public java.util.Vector getDisplayLimit(java.util.Locale locale)

  Returns the limit values, caring the format.

### getFormat

    public java.lang.String getFormat()

  Returns the format.

### getDefaultDateFormat

    public java.lang.String getDefaultDateFormat(java.util.Locale loc)

  This method can only be called when no user format is defined.

  Parameters:
    `loc` -
  Returns:

### getDefaultIndex

    public int getDefaultIndex()

  Returns the index of the current value in the value list. This value indicates the corresponding relationship between the current value and the value list only when setValue(...) or setDefaultIndex() is called after setValues().

### getOperation

    public int getOperation()

  Returns the operation used in the limitation.

  See Also:
    `jet.api.ParameterInfo.#UNKNOWN`, `jet.api.ParameterInfo.#BETWEEN`

### setFormat

    public void setFormat(java.lang.String str)

  Sets the format or sets the encoding of a string type parameter.

### setPrompt

    public void setPrompt(java.lang.String str)

### setValues

    public void setValues(java.util.Vector vStrValue,
                          java.util.Locale locale)
                   throws jet.exception.InvalidParameterException

  Sets(or changes) the value list of this parameter. After this method is called, the caller must select one from the list as the current value by calling the setDefaultIndex()or setValue() immediately. Otherwise, the corresponding relationship between the current value and the value list will be broken.

  Parameters:
    `vStrValue` - The value list to be set for the parameter. Elements are strings or `UserInput` .
    `locale` - The locale used to parse the non-expression elements. If the locale is null, default locale is used.
  Throws:
    `jet.exception.InvalidParameterException`

### setValues

    public void setValues(java.util.Vector vStrValue,
                          java.util.Locale locale,
                          DbValue currentValue)
                   throws jet.exception.InvalidParameterException

  Throws:
    `jet.exception.InvalidParameterException`

### setDefaultValue

    public void setDefaultValue(int index)

### setShowValues

    public void setShowValues(java.util.Vector values)

### getShowValues

    public java.util.Vector getShowValues()

  Gets the value list of a bind type parameter.

### clone

    public java.lang.Object clone()

  Overrides:
    `clone` in class `java.lang.Object`

### setDefaultIndex

    public void setDefaultIndex(int i)

  Selects the nth value in the value list as the current value. The current value will be changed if the value list is empty, but calling getInternalValue() will return "". Does nothing when isAllSetected() is true for the multi-value parameter. If i is -1, or larger than the size of the value list, selects the last one as the current value.

### equals

    public boolean equals(ParamDesc param)

  Does not compare name. Just compares other properties.

### parseInternalValue

    public DbValue parseInternalValue(java.lang.String inValue)
                               throws jet.exception.InvalidParameterException

  Checks whether the internal string (saved in the catalog) is OK.

  Throws:
    `jet.exception.InvalidParameterException`

### setValue

    public java.lang.String setValue(java.lang.String outVal,
                                     java.util.Locale locale)
                              throws jet.exception.InvalidParameterException

  Deprecated. Replaced by `setValue(UserInput, Timestamp, Locale)`

  Sets the current value of this parameter. If the format of the input value is not consistent with the locale, an InvalidParameterException will be thrown. After format checking, the input value will be checked to see if it is out of range in the value list when the parameter has a value list. There 3 options to choose when out of range: use default: the input value is discarded and uses getDefaultValue() as the current value; Warn: the input value is rejected and a warning message is thrown through InvalidParameterException. Use directly: applies the input value as the current value. If the input value passed the range checking, the return value of getDefaultIndex() will also be updated to the index of the input value in the value list. If the input value is not in the value list, it will be updated to -1.

  Throws:
    `jet.exception.InvalidParameterException`

### setValue

    public java.lang.String setValue(DbValue val,
                                     java.util.Locale locale)
                              throws jet.exception.InvalidParameterException

  Sets the user input value, and returns the display value based on the locale.

  Throws:
    `jet.exception.InvalidParameterException`

### resetTimeBaseLine

    public void resetTimeBaseLine(java.sql.Timestamp timeBaseLine)

### setValue

    public void setValue(jet.parameter.UserInput input,
                         java.sql.Timestamp timeBaseLine,
                         java.util.Locale locale,
                         java.util.TimeZone z)
                  throws jet.exception.InvalidParameterException

  Set the user input to parameter. This input can be a constant string or an expression and is wrapped into an `UserInput` object whose `isExpression()` will indicate it's a constant string or a expression.

  Parameters:
    `input` -
    `timeBaseLine` - expressions such as currentTime() will use this value as return value
    `locale` -
  Throws:
    `jet.formula.formulaExecutor.ExecFormulaFailedException`
    `jet.exception.ParseFormulaFailedException`
    `jet.exception.InvalidParameterException`

### setValue

    public void setValue(jet.parameter.UserInput input,
                         java.sql.Timestamp timeBaseLine,
                         java.util.Locale locale)
                  throws jet.exception.InvalidParameterException

  Throws:
    `jet.exception.InvalidParameterException`

### setValue

    public void setValue(jet.parameter.UserInput[] input,
                         java.sql.Timestamp timeBaseLine,
                         java.util.Locale locale,
                         java.util.TimeZone z)
                  throws jet.exception.InvalidParameterException

  Set the user inputs to parameter when parameter is multiple value. The input can be a constant string or an expression and is wrapped into an `UserInput` object whose `isExpression()` will indicate it's a constant string or a expression.

  Parameters:
    `inputs` -
    `timeBaseLine` - expressions such as currentTime() will use this value as return value
    `locale` -
  Throws:
    `jet.exception.InvalidParameterException`

### setValue

    public void setValue(jet.parameter.UserInput[] input,
                         java.sql.Timestamp timeBaseLine,
                         java.util.Locale locale)
                  throws jet.exception.InvalidParameterException

  Throws:
    `jet.exception.InvalidParameterException`

### check

    public void check(java.lang.String value,
                      java.util.Locale locale)
               throws jet.exception.InvalidParameterException

  Checks the value validation. return the correct string (especially useful for date/time types).

  Throws:
    `jet.exception.InvalidParameterException`

### isSimilar

    public boolean isSimilar(ParamDesc param)

  Judges whether the parameter specified is similar to this one. Just adds some values if they are the same.

### getBinding

    public java.lang.String getBinding()

  This method is associated with DynamicSortOrder feature. It returns a parameter name, and there are only two values in this parameter, 'Ascending' and 'Descending'.

### setBinding

    public void setBinding(java.lang.String binding)

### getColumn

    public java.lang.String getColumn()

  This method is associated with BindParameter feature. It returns the bind column.

### getColumns

    public java.util.Vector getColumns()

  This method is associated with BindParameter feature. It returns the display column.

### setColumn

    public void setColumn(java.lang.String column)

### setColumns

    public void setColumns(java.util.Vector v)

### setDistinct

    public void setDistinct(boolean isDis)

### isDistinct

    public boolean isDistinct()

### setEncoding

    public void setEncoding(java.lang.String encoding)

### setRequired

    public void setRequired(boolean isReq)

### isRequired

    public boolean isRequired()

  Whether this parameter is required or can be ignored.

### setDataSource

    public void setDataSource(java.lang.String sourceName)

  Parameters:
    `sourceName` - 1) the data source name where this parameter is defined in for type in NON dynamic parameter 2) the data source name of the value/show value columns which are bound to this bind column(include cascading) NON dynamic parameter 3) the data source name of the BV whose elements are bound to this bind column(include cascading) dynamic parameter NOTE: When this parameter is a type-in dynamic parameter, the data source of it is uncertain, no one know what to set. Generally, this method won't be called under this situation.

### getDataSource

    public java.lang.String getDataSource()

  Returns the data source name of 1) when this paramDesc is type in NON dynamic parameter, the return value is the data source name in which this parameter is defined 2) bind column parameter (include cascading) and not dynamic parameter, returns the data source name of the columns bind to this parameter 3) when this paramDesc is type is dynamic parameter, the return value is uncertain 4) when this paramDesc is type is bind column parameter (include cascading) dynamic parameter, returns the data source name of the BV whose elements are bound to this parameter

  Returns:

### getImportSql

    public java.lang.String getImportSql()

  Returns:
    Returns the importSql.

### setImportSql

    public void setImportSql(java.lang.String importSql)

  Parameters:
    `importSql` - The importSql to be set.

### getRelatedParamDescsByParam

    public static void getRelatedParamDescsByParam(java.util.Hashtable allPara,
                                                   java.util.Vector referPara,
                                                   ParamDesc param)

  If a parameter's type is Parameters, this method can be used to get all related parameter desc.

  Parameters:
    `referPara:` - ParamDesc collection.
    `para:` - current parameter desc.

### getFirstLevelRelatedParamByValue

    public static java.util.Vector getFirstLevelRelatedParamByValue(java.util.Hashtable allPara,
                                                                    ParamDesc param,
                                                                    java.lang.Object value)

  This meyhod is for server, which gets the related paramDesc according to the parameter's value, and only one level.

  Parameters:
    `allPara` -
    `param` -
    `value` -
  Returns:

### getFirstShowParamDescs

    public static void getFirstShowParamDescs(java.util.Hashtable allPara,
                                              java.util.Vector referPara,
                                              ParamDesc param,
                                              java.lang.Object value)

  If a parameter's type is parameters, If this value's corresponding parameter type is parameters, gets the corresponding parameter of this parameter default value.

  Parameters:
    `referPara` - : paraDesc collection.
    `para` - : current para.

### getFirstLevelParam

    public static void getFirstLevelParam(java.util.Hashtable allPara)

### getAllRelatedParamByValue

    public static void getAllRelatedParamByValue(java.util.Hashtable allPara,
                                                 java.util.Vector referPara,
                                                 ParamDesc param,
                                                 java.lang.Object value)

  If a parameter's type is parameters, gets all related parameters according to the value.

  Parameters:
    `referPara` - : ParamDesc collection.
    `param` - : current parameter.
    `value:` - current parameter's value.

### hasNestedPara

    public static boolean hasNestedPara(java.util.Hashtable allPara)

  This method checks whether the parameter's type is parameters or not for all parameters.

  Parameters:
    `allPara` -
  Returns:

### getReferPara

    public static java.util.Vector getReferPara(java.util.Hashtable allPara)

  Gets all parameters which is referenced by other parameters.

  Returns:
    a paramDesc collection.

### splitValue

    public static java.lang.String[] splitValue(java.lang.String value)

### IsParameters

    public boolean IsParameters()

### getImportParams

    public java.util.Vector getImportParams()

  Returns:
    Returns the importParams.

### setImportParams

    public void setImportParams(java.util.Vector importParams)

  Parameters:
    `importParams` - The importParams to be set.

### hasImportParam

    public static boolean hasImportParam(java.util.Vector allPara)

  If a parameter has import SQL and uses other parameters, returns true, else returns false.

  Parameters:
    `allPara` -
  Returns:

### isImportByPara

    public static boolean isImportByPara(ParamDesc param,
                                         ParamDesc curParam,
                                         java.util.Vector paramDescs)

### getReferedBy

    public java.util.Vector getReferedBy()

### getUpperLevels

    public java.util.Vector<ParamDesc> getUpperLevels()

### isReferedBy

    public boolean isReferedBy()

  Checks whether this paramDesc refers to by other paramDesc no matter through old(or new)cascading or by query.

  Returns:

### clearReferedBy

    public void clearReferedBy()

### isReferOther

    public boolean isReferOther()

  Checks whether this paramDesc refers to other paramDesc no matter through old(or new)cascading or by query.

  Returns:

### addReferParamToVsortParams

    public void addReferParamToVsortParams(java.util.Hashtable allParam,
                                           java.util.Hashtable curParamDescs,
                                           java.util.Vector sortParam)

### changedHashToVector

    public static java.util.Vector changedHashToVector(java.util.Hashtable hash)

### changedVectorToHash

    public static java.util.Hashtable changedVectorToHash(java.util.Vector v)

### transferValues

    public void transferValues(ParamDesc param)

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### isUseCurrentDate

    public boolean isUseCurrentDate()

  If returnS true, the parameter is a dynamic date parameter.

  Returns:

### setUseCurrentDate

    public boolean setUseCurrentDate(boolean useCurrentDate)

  Sets the parameter whether it is a dynamic date parameter or not. When the set value is true and the parameter's data type is not Date, Time, or DateTime, the set operation will be ignored, and returns false. Others, sets the field with the set value, and returns true.

  Parameters:
    `useCurrentDate.` -
  Returns:
    boolean value.

### isUseCurrentDateWhenBlank

    public boolean isUseCurrentDateWhenBlank()

  If returns true, the parameter will return the current date when the parameter is blank.

  Returns:

### setUseCurrentDateWhenBlank

    public boolean setUseCurrentDateWhenBlank(boolean useCurrentDateWhenBlank)

  Sets the parameter if the parameter will return the current date when the parameter is blank. When the set value is true and the parameter's data type is not Date, Time, or DateTime, the set operation will be ignored, and returns false. Others, sets the field with the set value, and returns true.

  Parameters:
    `useCurrentDateWhenBlank.` -
  Returns:
    boolean value.

### getDynamicValue

    public DbValue getDynamicValue(long dynamicValue,
                                   java.util.Locale local)

  Gets a dynamic value[Date, Time, DateTime] base on a dynamic template and input the long time, and the local. If the parameter is not dynamic, returns null value; else if the parameter data type is Date, the return value is a DbDate instance; else if the parameter data type is Time, the return value is a DbTime instance; else if the parameter data type is DateTime, the return value is a DbTimestamp instance. The illegal invoke situation is: the current parameter is not dynamic or it's data type is not Date, Time, or DateTime.

  Parameters:
    `dynamicValue.` -
    `local.` -
  Returns:
    a DbValue.

### setDynamicTemplate

    public boolean setDynamicTemplate(java.lang.String dynamicTemplate)

  If the set dynamicTemplate is legal, replaces previous the dynamicTemplate with the currently set dynamicTemplate, and returns true. If the set dynamicTemplate is illegal, does not change anything, and returns false.

  Parameters:
    `dynamicTemplate.` -
  Returns:

### getDynamicTemplate

    public java.lang.String getDynamicTemplate()

  Returns:

### setHideParameterWhenSingleValueReturn

    public void setHideParameterWhenSingleValueReturn(boolean isHideParameterWhenSingleValueReturn)

  Parameters:
    `isHideParameterWhenSingleValueReturn` - is a boolean value. If the parameter value is true, the parameter maybe be hidden when a single value is returned, else doesn't hide the parameter.

### isHideParameterWhenSingleValueReturn

    public boolean isHideParameterWhenSingleValueReturn()

  Returns:
    is a boolean value. If the return value is true, the parameter may be hidden when a single value is returned, else doesn't hide the parameter.

### setIsMultipleValue

    public void setIsMultipleValue(boolean isMultipleValue)

  Parameters:
    `isMultipleValue` -

### isMultipleValue

    public boolean isMultipleValue()

  Returns:

### getMultiDisplayValue

    public java.lang.String[] getMultiDisplayValue(fArray paramvalue,
                                                   java.util.Locale locale,
                                                   java.util.TimeZone z)

  Parameters:
    `paramvalue` -
    `locale` -
  Returns:

### getMultiDisplayValue

    public java.lang.String[] getMultiDisplayValue(fArray paramvalue,
                                                   java.util.Locale locale)

### setValue

    public java.lang.String[] setValue(java.lang.String[] inputValues,
                                       java.util.Locale locale)
                                throws jet.exception.InvalidParameterException

  Deprecated. Replaced by `setValue(UserInput[], Timestamp, Locale)`

  Parameters:
    `inputValues` -
    `locale` -
  Returns:
  Throws:
    `jet.exception.InvalidParameterException`

### setValue

    public java.lang.String[] setValue(fArray val,
                                       java.util.Locale locale)
                                throws jet.exception.InvalidParameterException

  Parameters:
    `val` -
    `locale` -
  Returns:
  Throws:
    `jet.exception.InvalidParameterException`

### getMultiStrValue

    public java.lang.String[] getMultiStrValue()

  Returns:

### setSelectedValues

    public void setSelectedValues(java.util.Vector selectedValues)

### getSelectedValues

    public java.util.Vector getSelectedValues()

### isCascading

    public boolean isCascading()

  This flag must be set by calling setBeColumn(ParamDesc.CASCADING).

  Returns:

### setIsCascading

    public void setIsCascading(boolean isCascading)

### setCascadingInfo

    public void setCascadingInfo(java.lang.String chainID,
                                 java.lang.String previousLevel,
                                 java.lang.String nextLevel,
                                 boolean isSetAsParameter)

### getChainID

    public java.lang.String getChainID()

### getPreviousLevel

    public java.lang.String getPreviousLevel()

### getNextLevel

    public java.lang.String getNextLevel()

### isSetAsParameter

    public boolean isSetAsParameter()

### setAllSelected

    public void setAllSelected(boolean isAllSelected)

### isAllSelected

    public boolean isAllSelected()

### setAllowAll

    public void setAllowAll(boolean allow)

### isAllowAll

    public boolean isAllowAll()

### setAllowTypeIn

    public void setAllowTypeIn(boolean allowTypeIn)

### isAllowTypeIn

    public boolean isAllowTypeIn()

### setWhenOutOfRange

    public void setWhenOutOfRange(int whenOutOfRange)

### getWhenOutOfRange

    public int getWhenOutOfRange()

### setValueList

    public void setValueList(java.util.Vector values)
                      throws jet.exception.InvalidParameterException

  Deprecated.

  Throws:
    `jet.exception.InvalidParameterException`
  Since:
    v10.1 update2

### setValueList

    public void setValueList(java.util.Vector values,
                             java.util.Vector showValues)

### detectInvalidValues

    public java.lang.String[] detectInvalidValues(java.lang.String[] target,
                                                  java.util.Locale locale)
                                           throws jet.exception.InvalidParameterException

  Deprecated. `setValue` method will do the outOfRange check, this method is useless now

  Throws:
    `jet.exception.InvalidParameterException`

### setAllowUseExpression

    public void setAllowUseExpression(boolean allowUseExpression)

### allowUseExpression

    public boolean allowUseExpression()

### getLocalizedUserFormat

    public java.lang.String getLocalizedUserFormat(java.util.Locale locale)

### getValueList

    public java.util.Vector[] getValueList()

### isGetValueFromAPI

    public boolean isGetValueFromAPI()

### setGetValueFromAPI

    public void setGetValueFromAPI(boolean b)

### copy

    public void copy(ParamDesc that)

  Copy the current value, value list of specified (that) parameter to this parameter without checking the value is out of range or not. The value, and items of the value list is cloned to this parameter. The copy action won't start if the 2 parameter have different name.

  Parameters:
    `that` -

### setIsDynamicParam

    public void setIsDynamicParam(boolean isDynamicParam)

### isDynamicParam

    public boolean isDynamicParam()

### setBVName

    public void setBVName(java.lang.String bvName)

### getBVName

    public java.lang.String getBVName()

### setDataMappingFile

    public void setDataMappingFile(java.lang.String dataMapping)

### setQueryName

    public void setQueryName(java.lang.String queryName)

### getQueryName

    public java.lang.String getQueryName()

### format

    public java.lang.String format(DbValue v,
                                   java.lang.String pattern,
                                   java.util.Locale l,
                                   java.util.TimeZone z)

  FeatureImplement #118058 FeatureImplement_NLS enhancement

  Parameters:
    `v` -
    `pattern` -
    `l` -
    `z` -
  Returns:

### formatMultiple

    public java.lang.String[] formatMultiple(fArray v,
                                             java.lang.String pattern,
                                             java.util.Locale l,
                                             java.util.TimeZone z)

### setNLSApplyParam

    public void setNLSApplyParam(jet.util.nls.NLSApplyParam nls)

### setDatamapping

    public void setDatamapping(java.lang.String dataMapping)

### getValueList

    public java.util.Vector<jet.parameter.runtime.valuelist.item.ValueListItem> getValueList(java.util.Locale l,
                                                                                             boolean needTranslate)

  For FS #118058 FeatureImplement_NLS enhancement This method can translate each item of a parameter value list into another language. The value list to translate could be: 1) when this parameter is a bind column parameter(include cascading), the value lsit is loaded from database or some other data source 2) when this parameter is used as 'group by', the value list is set by caller to call `setValues(Vector, Locale)` or similar method 3) when this parameter is created with default values defined 4) when this parameter has been inputed some value, the last inputed value maybe hold in value list of this parameter This method does not concern about what the language source and target language is. It just calls translate tool(JFieldValueNLSManager or MetaNLSKit) to get a translated string.

  Parameters:
    `l` -
    `needTranslate` - should translate the value list item to another language or not
  Returns:
    Vector of ValueListItem.

### getValueList

    public java.util.Vector<jet.parameter.runtime.valuelist.item.ValueListItem> getValueList(java.util.Locale l)

  Parameters:
    `l` -
  Returns:

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD